﻿using System;
using Xamarin.Forms;

namespace MRTestZoomImage
{
	public class ZoomableImage : MR.Gestures.Image
	{
		public ZoomableImage()
		{
			Pinching += delegate(object sender, MR.Gestures.PinchEventArgs e) {
				System.Diagnostics.Debug.WriteLine("Pinch: {0}, {1}", e.DeltaScale, e.TotalScale);
				Scale = Math.Min(5, Math.Max(0.1, Scale * e.DeltaScale));
				if(Scale <= 1.0)
					TranslationX = TranslationY = 0;
			};
			Panning += delegate(object sender, MR.Gestures.PanEventArgs e) {
				if(Scale > 1.0)
				{
					if (Device.OS == TargetPlatform.WinPhone)
					{
						TranslationX += e.DeltaDistance.X * Scale;		// unfortunately this has to be specified differently on WinPhone
						TranslationY += e.DeltaDistance.Y * Scale;		// another bug in Xamarin Forms IMHO
					}
					else
					{
						TranslationX += e.DeltaDistance.X;
						TranslationY += e.DeltaDistance.Y;
					}
				}
				else
					TranslationX = TranslationY = 0;
			};
		}

		protected override void OnPropertyChanged(string propertyName = null)
		{
			base.OnPropertyChanged(propertyName);

			if(propertyName == SourceProperty.PropertyName)
			{
				TranslationX = TranslationY = 0;
				Scale = 1.0;
			}
		}
	}
}

